;
;	Disassembled by:
;		DASMx object code disassembler
;		(c) Copyright 1996, 1997 Conquest Consultants
;		Version 1.10 (Jul 16 1997)
;
;	File:	bt.bin
;	Date:	Thu Mar 11 22:06:50 2021
;	CPU:	Intel 8048
;
; PORT P1 - stav BT100 (P1.0..P1.3), rizeni BT100 (P1.4..P1.7)
;	P1.0	doraz voziku
;	P1.1	SYNC voziku
;	P1.2	BOD voziku
;	P1.3	SYNC papiru
;	P1.4	vozik VPRAVO
;	P1.5	vozik VLEVO
;	P1.6	buzeni jehly
;	P1.7	posuv papiru
;
; PORT P2 - rizeni pameti, cteni dat, tlacitka, LED
;	P2.0	01	A8 RAM/EPROM
;	P2.1	02	A9 RAM/EPROM
;	P2.2	04	A10 RAM/EPROM
;	P2.3	08	read input data
;	P2.4	10	ACK
;	P2.5	20	LED ERROR
;	P2.6	40	tlacitko STOP
;	P2.7	80	tlacitko START
; -------------------------------------
;	REGISTRY PRO TISK
; RB0 - R0	ADRESA BUFF.TISK L
;	R1	PULSY PRI OTOC - PAMET
;	R2	PULSY PRI OTOC - NAVIC
;	R3	UNIVERSAL
;	R4	POCET ZNAKU
;	R5	ROTACE ZNAKU
;	R6	ADRESA BUFF.TISK H
;	R7	AKT. RADEK GENERATORU
;
;	REGISTRY PRO PAMET
; RB1 - R0
;	R1
;	R2
;	R3	POCET ZNAKU
;	R4	ADRESA BUFF.TISK L
;	R5	ADRESA BUFF.TISK H
;	R6	ADRESA BUFF.ZAPIS L
;	R7	ADRESA BUFF.ZAPIS H
;
; F0	- '0'	nebyl konec stranky, mozno prijimat a ukladat znaky
;	- '1'	byl konec stranky, znaky jen prijimej, ale neukladej
; F1	- '0'	ASCII
;	- '1'	GRAFICKY
; -------------------------------------

	.org	$0000
INI:	sel	rb0		; banka registru pro tisk
	mov	a,#$0F		; priprava LOW poloviny P1 pro vstup
	outl	p1,a		; nastav P1
	clr	f0		; nuluj CF0
	clr	f1		; nuluj CF1
	mov	a,#$C0		; P26 a P2.7 budou vstup (tlacitka)
	outl	p2,a		; nastav P2
	clr	a		; nuluj Acc
	sel	rb1		; banka registru pamet
	mov	r3,a		; nuluj pocet znaku v bufferu
	mov	r4,a		; adresa v bufferu pro cteni
	mov	r5,a
	mov	r6,a		; adresa v bufferu pro zapis
	mov	r7,a
	sel	rb0		; banka registru pro tisk
	call	L07AA		; nalezeni vychozi polohy voziku, odradkovani
L0013:	jnt0	L0049		; je-li STB=0, skoc
	in	a,p2		; cti P2
	anl	a,#$80		; test tlacitka START
	jz	L0013		; neni stisknuto, cekej dal
; naplneni bufferu DEMO tiskem
	mov	r2,#$80		; pocet znaku k tisku
L001C:	mov	a,r2		; vytvoreni hodnoty tisknuteho znaku
	cpl	a		;   ze zbyvajiciho poctu
	add	a,#$A1		;   znaku demo vytisku
	call	L0081		; vloz DEMO znak do bufferu
	djnz	r2,L001C	; opkuj pro celou znakovou sadu
; Tisk dat z bufferu (RAM)
L0024:	clr	f0		; nuluj FLAG0
	cpl	f0		; nastav FLAG0
	sel	rb1		; banka registru pro pamet
	mov	a,r4		; LOW adresa bufferu pro cteni
	mov	r2,a		; dej do R2
	mov	a,r5		; HIGH adresa bufferu pro cteni
	mov	r3,a		; dej do R3
	sel	rb0		; banka registru pro tisk
	mov	r7,#$00		; nuluj aktivni radek generatoru znaku
	mov	r2,#$0C		; vyska znaku v mikroradcich
L0030:	mov	r4,#$28		; pocet znaku na radku (40)
	jf1	L0036		; je-li FLAG1=1, skoc (tisk grafiky)
	mov	r4,#$50		; pocet znaku radku (80)
L0036:	sel	rb1		; banka registru pro pamet
	mov	a,r2		; LOW adresa bufferu pro cteni
	mov	r4,a		; uprav LOW adresu bufferu pro cteni
	mov	a,r3		; HIGH adresa bufferu pro cteni
	mov	r5,a		; uprav HIGH adresu bufferu pro cteni
	sel	rb0		; banka registru pro tisk
L003C:	call	L00A5		; vytiskne mikroradek 1 znaku z bufferu
	djnz	r4,L003C	; vytiskni cely mikroradek z bufferu
	call	L07AA		; navrat voziku, SYNC, odradkovani mikroradku
	inc	r7		; dalsi mikroradek generatoru
	djnz	r2,L0030	; opakuj pro vsech 12 mikroradku
	jf0	L0024		; jeli FLAG0=1, skoc
	jmp	INI		; buffer vypraznden, zinicializuj BT100 i interface

; Zpracovani aktivniho /STB z MH3212
L0049:	jf0	L0060		; je-li FLAG0=1, skoc
	mov	a,#$E8		; cteni dat z MH3212 - zde mozno shodit i /ACK
	outl	p2,a		; nastav na portu
	movx	a,@r0		; precti byte z MH3212
	mov	r1,a		; dej precteny byte do R1
	add	a,#$E0		; je znak mensi nez ' '?
	jnc	L0067		; je mensi, skoc
	anl	a,#$7F		; vyznamnych jen 7 bitu
	add	a,#$20		; vrat zpatky ASCII hodnotu znaku
	mov	r1,a		; dej do R1
L0059:	mov	a,r1		; precteny znak do Acc
	call	L0081		; vloz znak do bufferu (RAM)
L005C:	jf0	L0060		; je-li FLAG0=1, skoc - byl konec stranky, cekej na START
	jnt0	L0049		; je-li TEST0=0, opakuj cteni
L0060:	in	a,p2		; cti P2
	anl	a,#$80		; test tlacitka START
	jz	L005C		; nestisknuto, cti pripadne dalsi znak
	jmp	L0024		; zahaj tisk dat z bufferu

; Test na znaky 0Ch (konec stranky), 0Dh (konec radku) a 18h (graficky tisk)
L0067:	jf1	L0059		; je-li FLAG1=1, skoc
	mov	a,r1		; znak prijaty z MH3212
	add	a,#$F3		; test na 0Dh - konec radku
	jz	L0059		; je 0Dh, pokracuj vlozenim do bufferu a ctenim dalsiho znaku
	inc	a		; test na 0Ch - konec stranky
	jz	L007A		; je 0Ch, skoc
	mov	a,r1		; prijaty znak
	add	a,#$E8		; test na 18h - rizeni tisku grafiky
	jnz	L005C		; nebylo, pokracuj ctenim dalsiho znaku
	clr	f1		; nuluj FLAG1
	cpl	f1		; nastav FLAG1
	jmp	L005C		; cti dalsi znak z MH3212

L007A:	clr	f0		; nuluj FLAG0
	cpl	f0		; nastav FLAG0 - byl konec stranky
	mov	a,#$F0		; tlacitka pro cteni, LED OFF, /ACK=1
	outl	p2,a		; nastav port P2
	jmp	L0059		; cteni dalsiho znaku z MH3212

; ulozeni znaku z Acc do tiskoveho bufferu adresovaneho R7:R6
L0081:	sel	rb1		; banka registru pro pamet
	mov	r1,a		; odloz znak ukladany do bufferu
	mov	a,r6		; LOW adresa v bufferu pro zapis
	mov	r0,a		; adresa pro neprimou adresaci pameti
	mov	a,r7		; HIGH adresa v bufferu pro zapis
	orl	a,#$E0		; zkombinuj s LED a tlacitky
	outl	p2,a		; nastav HIGH adresu RAM (A8..A10)
	mov	a,r1		; obnov znak k ulozeni
	movx	@r0,a		; uloz znak do bufferu (RAM)
	mov	a,r0		; LOW adresa ulozeneho znaku
	inc	a		; posun na dalsi adresu
	mov	r6,a		; vrat na misto
	jz	L0092		; doslo k preteceni LOW adresy, skoc
	sel	rb0		; banka registru pro tisk
	ret			; navrat

L0092:	inc	r7		; zvys HIGH adresu pro zapis do bufferu
	mov	a,r7		; cti vysledek
	anl	a,#$F8		; ponech jen 3 nejnizsi bity (A8..A10)
	sel	rb0		; banka registru pro tisk
	jnz	L009A
	ret

L009A:	clr	f0		; nuluj FLAG0
	cpl	f0		; nastav FLAG0
	ret			; navrat

L009D:	clr	f0		; nuluj FLAG0
	mov	a,#$C0		; rozsvit LED ERROR
	outl	p2,a		; nastav na portu
L00A1:	sel	rb0		; banka registru pro tisk
	mov	r4,#$01		; pocet znaku
	ret			; navrat

; Z bufferu (RAM) vyzvedne dalsi znak k tisku. Kontroluje, zda neslo k preteceni adresy
; za adresu pro zapis do bufferu, konroluje odradkovani (0Dh) a odstrankovani (0Ch).
; Pokracuje vyhledanim prislusneho mikroradku v generatoru znaku
L00A5:	sel	rb1		; banka registru pro pamet
	mov	a,r5		; HIGH adresa bufferu pro cteni
	cpl	a		; prevod na dvojkovy doplnek
	inc	a		;   kontrola, zda jsou v bufferu nejaka data
	add	a,r7		; HIGH byte adresy bufferu pro zapis
	jnz	L00B2
	mov	a,r4		; LOW adresa bufferu pro cteni
	cpl	a		; prevod na dvojkovy doplnek
	inc	a
	add	a,r6		; LOW adresa bufferu pro zapis
	jz	L009D		; zpracovani podteceni znakoveho bufferu
L00B2:	mov	a,r4		; LOW adresa bufferu pro cteni
	mov	r0,a		; adresa pro neprimou adresaci pameti (RAM)
	mov	a,r5		; HIGH adresa bufferu pro cteni
	orl	a,#$D0		; zkombunuj s LED a tlacitky
	outl	p2,a		; nastav HIGH adresu RAM (A8..A10)
	inc	r4		; dalsi adresa pro cteni z bufferu
	mov	a,r4		; kontrola preteceni
	jnz	L00BD		; nepreteklo, skoc
	inc	r5		; uprav i HIGH byte
L00BD:	movx	a,@r0		; cti znak k tisku z bufferu (RAM)
	mov	r1,a		; znak k tisku do R1
	add	a,#$F3		; test na 0Dh - konec radku
	jz	L00A1		; je, odradkovani
	inc	a		; test na 0Ch - konec stranky
	jz	L009D		; je, odstrankovani
	mov	a,r1		; obnov znak k tisku
	sel	rb0		; banka registru pro tisk
	jmp	HLED		; vyhledej a precti mikroradek z gen. znaku

	.org	$0100
table1:	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; ' '
	.db	$00,$00,$00,$00
	.db	$00,$00,$04,$04,$04,$04,$04,$00 ; '!'
	.db	$04,$00,$00,$00
	.db	$00,$00,$0A,$0A,$0A,$00,$00,$00 ; '"'
	.db	$00,$00,$00,$00
	.db	$00,$00,$0A,$0A,$1F,$0A,$1F,$0A ; '#'
	.db	$0A,$00,$00,$00
	.db	$00,$00,$04,$1E,$05,$0E,$14,$0F ; '$'
	.db	$04,$00,$00,$00
	.db	$00,$00,$03,$13,$08,$04,$02,$19 ; '%'
	.db	$18,$00,$00,$00
	.db	$00,$00,$02,$05,$05,$02,$15,$09 ; '&'
	.db	$16,$00,$00,$00
	.db	$00,$04,$04,$04,$00,$00,$00,$00 ; '''
	.db	$00,$00,$00,$00
	.db	$00,$00,$04,$02,$01,$01,$01,$02 ; '('
	.db	$04,$00,$00,$00
	.db	$00,$00,$04,$08,$10,$10,$10,$08 ; ')'
	.db	$04,$00,$00,$00
	.db	$00,$00,$04,$15,$0E,$04,$0E,$15 ; '*'
	.db	$04,$00,$00,$00
	.db	$00,$00,$00,$04,$04,$1F,$04,$04 ; '+'
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; ','
	.db	$04,$04,$02,$00
	.db	$00,$00,$00,$00,$00,$1F,$00,$00 ; '-'
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; '.'
	.db	$04,$00,$00,$00
	.db	$00,$00,$00,$10,$08,$04,$02,$01 ; '/'
	.db	$00,$00,$00,$00
	.db	$00,$00,$0E,$11,$19,$15,$13,$11 ; '0'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$04,$06,$04,$04,$04,$04 ; '1'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$0E,$11,$10,$0E,$01,$01 ; '2'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$1F,$10,$08,$0C,$10,$11 ; '3'
	.db	$0E,$00,$00,$00

S1:	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7		; aktivni radek generatoru znaku
	movp	a,@a		; cti mikroradek znaku z generatoru znaku
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0200
table2:	.db	$00,$00,$08,$0C,$0A,$1F,$08,$08 ; '4'
	.db	$08,$00,$00,$00
	.db	$00,$00,$1F,$01,$0F,$10,$10,$11 ; '5'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$1C,$02,$01,$0F,$11,$11 ; '6'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$1F,$10,$10,$08,$04,$02 ; '7'
	.db	$01,$00,$00,$00
	.db	$00,$00,$0E,$11,$11,$0E,$11,$11 ; '8'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$0E,$11,$11,$1E,$10,$08 ; '9'
	.db	$07,$00,$00,$00
	.db	$00,$00,$00,$00,$04,$00,$04,$00 ; ':'
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$04,$00 ; ';'
	.db	$04,$04,$02,$00
	.db	$00,$00,$08,$04,$02,$01,$02,$04 ; '<'
	.db	$08,$00,$00,$00
	.db	$00,$00,$00,$00,$1F,$00,$1F,$00 ; '='
	.db	$00,$00,$00,$00
	.db	$00,$00,$02,$04,$08,$10,$08,$04 ; '>'
	.db	$02,$00,$00,$00
	.db	$00,$00,$0E,$11,$10,$0C,$04,$00 ; '?'
	.db	$04,$00,$00,$00
	.db	$00,$00,$0E,$11,$15,$1D,$0D,$01 ; '@'
	.db	$1E,$00,$00,$00
	.db	$00,$00,$04,$0A,$11,$11,$1F,$11 ; 'A'
	.db	$11,$00,$00,$00
	.db	$00,$00,$0F,$11,$11,$0F,$11,$11 ; 'B'
	.db	$0F,$00,$00,$00
	.db	$00,$00,$0E,$11,$01,$01,$01,$11 ; 'C'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$0F,$11,$11,$11,$11,$11 ; 'D'
	.db	$0F,$00,$00,$00
	.db	$00,$00,$1F,$01,$01,$0F,$01,$01 ; 'E'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$1F,$01,$01,$0F,$01,$01 ; 'F'
	.db	$01,$00,$00,$00
	.db	$00,$00,$1E,$11,$01,$01,$19,$11 ; 'G'
	.db	$1E,$00,$00,$00

S2:	add	a,#$14
	rl	a		; x2
	rl	a		; x4
	mov	r3,a		; mezivysledek
	rl	a		; x8
	add	a,r3		; x12
	add	a,r7		; aktivni mikroradek
	movp	a,@a		; cti mikroradek znaku z gen. znaku
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0300
table3:	.db	$00,$00,$11,$11,$11,$1F,$11,$11 ; 'H'
	.db	$11,$00,$00,$00
	.db	$00,$00,$0E,$04,$04,$04,$04,$04 ; 'I'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$10,$10,$10,$10,$10,$11 ; 'J'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$11,$09,$05,$03,$05,$09 ; 'K'
	.db	$11,$00,$00,$00
	.db	$00,$00,$01,$01,$01,$01,$01,$01 ; 'L'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$11,$1B,$15,$15,$15,$11 ; 'M'
	.db	$11,$00,$00,$00
	.db	$00,$00,$11,$11,$13,$15,$19,$11 ; 'N'
	.db	$11,$00,$00,$00
	.db	$00,$00,$0E,$11,$11,$11,$11,$11 ; 'O'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$0F,$11,$11,$0F,$01,$01 ; 'P'
	.db	$01,$00,$00,$00
	.db	$00,$00,$0E,$11,$11,$11,$15,$09 ; 'Q'
	.db	$16,$00,$00,$00
	.db	$00,$00,$0F,$11,$11,$0F,$05,$09 ; 'R'
	.db	$11,$00,$00,$00
	.db	$00,$00,$0E,$11,$01,$0E,$10,$11 ; 'S'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$1F,$15,$04,$04,$04,$04 ; 'T'
	.db	$04,$00,$00,$00
	.db	$00,$00,$11,$11,$11,$11,$11,$11 ; 'U'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$11,$11,$11,$0A,$0A,$04 ; 'V'
	.db	$04,$00,$00,$00
	.db	$00,$00,$11,$11,$11,$15,$15,$15 ; 'W'
	.db	$0A,$00,$00,$00
	.db	$00,$00,$11,$11,$0A,$04,$0A,$11 ; 'X'
	.db	$11,$00,$00,$00
	.db	$00,$00,$11,$11,$0A,$04,$04,$04 ; 'Y'
	.db	$04,$00,$00,$00
	.db	$00,$00,$1F,$10,$08,$04,$02,$01 ; 'Z'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$1E,$02,$02,$02,$02,$02 ; '['
	.db	$1E,$00,$00,$00

S3:	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7
	movp	a,@a
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0400
table4:	.db	$00,$00,$00,$01,$02,$04,$08,$10 ; '\'
	.db	$00,$00,$00,$00
	.db	$00,$00,$0F,$08,$08,$08,$08,$08 ; ']'
	.db	$0F,$00,$00,$00
	.db	$00,$00,$04,$0E,$15,$04,$04,$04 ; '^'
	.db	$04,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; '_'
	.db	$00,$1F,$00,$00
	.db	$00,$00,$02,$04,$08,$00,$00,$00 ; '`'
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00,$0E,$10,$1E,$11 ; 'a'
	.db	$1E,$00,$00,$00
	.db	$00,$00,$01,$01,$0F,$11,$11,$11 ; 'b'
	.db	$0F,$00,$00,$00
	.db	$00,$00,$00,$00,$0E,$01,$01,$01 ; 'c'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$10,$10,$1E,$11,$11,$11 ; 'd'
	.db	$1E,$00,$00,$00
	.db	$00,$00,$00,$00,$0E,$11,$1F,$01 ; 'e'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$08,$04,$04,$0E,$04,$04 ; 'f'
	.db	$04,$00,$00,$00
	.db	$00,$00,$00,$00,$1E,$11,$11,$11 ; 'g'
	.db	$1E,$10,$0C,$00
	.db	$00,$00,$01,$01,$0F,$11,$11,$11 ; 'h'
	.db	$11,$00,$00,$00
	.db	$00,$00,$04,$00,$06,$04,$04,$04 ; 'i'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$08,$00,$0C,$08,$08,$08 ; 'j'
	.db	$08,$08,$06,$00
	.db	$00,$00,$02,$02,$12,$0A,$06,$0A ; 'k'
	.db	$12,$00,$00,$00
	.db	$00,$00,$06,$04,$04,$04,$04,$04 ; 'l'
	.db	$0E,$00,$00,$00
	.db	$00,$00,$00,$00,$0B,$15,$15,$15 ; 'm'
	.db	$15,$00,$00,$00
	.db	$00,$00,$00,$00,$0F,$11,$11,$11 ; 'n'
	.db	$11,$00,$00,$00
	.db	$00,$00,$00,$00,$0E,$11,$11,$11 ; 'o'
	.db	$0E,$00,$00,$00

S4	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7
	movp	a,@a
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0500
table5:	.db	$00,$00,$00,$00,$0F,$11,$11,$11 ; 'p'
	.db	$0F,$01,$01,$00
	.db	$00,$00,$00,$00,$1E,$11,$11,$11 ; 'q'
	.db	$1E,$10,$10,$00
	.db	$00,$00,$00,$00,$0E,$12,$02,$02 ; 'r'
	.db	$02,$00,$00,$00
	.db	$00,$00,$00,$00,$1E,$01,$0E,$10 ; 's'
	.db	$0F,$00,$00,$00
	.db	$00,$00,$00,$04,$0E,$04,$04,$04 ; 't'
	.db	$08,$00,$00,$00
	.db	$00,$00,$00,$00,$11,$11,$11,$11 ; 'u'
	.db	$1E,$00,$00,$00
	.db	$00,$00,$00,$00,$11,$11,$11,$0A ; 'v'
	.db	$04,$00,$00,$00
	.db	$00,$00,$00,$00,$11,$11,$15,$15 ; 'w'
	.db	$0A,$00,$00,$00
	.db	$00,$00,$00,$00,$11,$0A,$04,$0A ; 'x'
	.db	$11,$00,$00,$00
	.db	$00,$00,$00,$00,$11,$11,$11,$11 ; 'y'
	.db	$1E,$10,$0C,$00
	.db	$00,$00,$00,$00,$1F,$08,$04,$02 ; 'z'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$08,$04,$04,$02,$04,$04 ; '{'
	.db	$08,$00,$00,$00
	.db	$00,$04,$04,$04,$04,$04,$04,$04 ; '|'
	.db	$04,$04,$00,$00
	.db	$00,$00,$02,$04,$04,$08,$04,$04 ; '}'
	.db	$02,$00,$00,$00
	.db	$00,$00,$00,$00,$02,$15,$08,$00 ; '~'
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; '_'
	.db	$1F,$1F,$00,$00
	.db	$00,$00,$00,$00,$00,$00,$00,$00 ; ' '
	.db	$00,$00,$00,$00
	.db	$10,$08,$04,$0A,$11,$11,$1F,$11 ; 'Á'
	.db	$11,$00,$00,$00
	.db	$0A,$04,$0E,$11,$01,$01,$01,$11 ; 'Č'
	.db	$0E,$00,$00,$00
	.db	$0A,$04,$0F,$11,$11,$11,$11,$11 ; 'Ď'
	.db	$0F,$00,$00,$00

S5:	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7
	movp	a,@a
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0600
table6:	.db	$08,$04,$1F,$01,$01,$0F,$01,$01 ; 'É'
	.db	$1F,$00,$00,$00
	.db	$0A,$04,$1F,$01,$01,$0F,$01,$01 ; 'Ě'
	.db	$1F,$00,$00,$00
	.db	$08,$04,$0E,$04,$04,$04,$04,$04 ; 'Í'
	.db	$0E,$00,$00,$00
	.db	$0A,$04,$11,$11,$13,$15,$19,$11 ; 'Ň'
	.db	$11,$00,$00,$00
	.db	$08,$04,$0E,$11,$11,$11,$11,$11 ; 'Ó'
	.db	$0E,$00,$00,$00
	.db	$0A,$04,$0F,$11,$11,$0F,$05,$09 ; 'Ř'
	.db	$11,$00,$00,$00
	.db	$0A,$04,$0E,$11,$01,$0E,$10,$11 ; 'Š'
	.db	$0E,$00,$00,$00
	.db	$0A,$04,$1F,$15,$04,$04,$04,$04 ; 'Ť'
	.db	$04,$00,$00,$00
	.db	$08,$04,$11,$11,$11,$11,$11,$11 ; 'Ú'
	.db	$0E,$00,$00,$00
	.db	$04,$0A,$15,$11,$11,$11,$11,$11 ; 'Ů'
	.db	$0E,$00,$00,$00
	.db	$08,$04,$11,$11,$0A,$04,$04,$04 ; 'Ý'
	.db	$04,$00,$00,$00
	.db	$0A,$04,$1F,$10,$08,$04,$02,$01 ; 'Ž'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$00,$10,$0E,$0B,$0A,$0A ; Pí
	.db	$0A,$00,$00,$00
	.db	$00,$08,$04,$00,$0E,$10,$1E,$11 ; 'á'
	.db	$1E,$00,$00,$00
	.db	$00,$14,$08,$00,$1E,$01,$01,$01 ; 'č'
	.db	$1E,$00,$00,$00
	.db	$0A,$04,$10,$10,$1E,$11,$11,$11 ; 'ď'
	.db	$1E,$00,$00,$00
	.db	$00,$08,$04,$00,$0E,$11,$1F,$01 ; 'é'
	.db	$0E,$00,$00,$00
	.db	$00,$0A,$04,$00,$0E,$11,$1F,$01 ; 'ě'
	.db	$0E,$00,$00,$00
	.db	$00,$08,$04,$00,$06,$04,$04,$04 ; 'í'
	.db	$0E,$00,$00,$00
	.db	$00,$0A,$04,$00,$0F,$11,$11,$11 ; 'ň'
	.db	$11,$00,$00,$00

S6:	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7
	movp	a,@a
	jmp	L078C		; vytiskni mikroradek znaku

	.org	$0700
table7:	.db	$00,$08,$04,$00,$0E,$11,$11,$11 ; 'ó'
	.db	$0E,$00,$00,$00
	.db	$00,$0A,$04,$00,$0E,$12,$02,$02 ; 'ř'
	.db	$02,$00,$00,$00
	.db	$00,$0A,$04,$00,$1E,$01,$0E,$10 ; 'š'
	.db	$0F,$00,$00,$00
	.db	$14,$08,$00,$04,$0E,$04,$04,$04 ; 'ť'
	.db	$08,$00,$00,$00
	.db	$00,$08,$04,$00,$11,$11,$11,$11 ; 'ú'
	.db	$1E,$00,$00,$00
	.db	$04,$0A,$04,$00,$11,$11,$11,$11 ; 'ů'
	.db	$1E,$00,$00,$00
	.db	$00,$08,$04,$00,$11,$11,$11,$11 ; 'ý'
	.db	$1E,$10,$0C,$00
	.db	$00,$0A,$04,$00,$1F,$08,$04,$02 ; 'ž'
	.db	$1F,$00,$00,$00
	.db	$00,$00,$0E,$11,$11,$11,$0A,$0A ; Omega
	.db	$1B,$00,$00,$00

S7:	add	a,#$14
	rl	a
	rl	a
	mov	r3,a
	rl	a
	add	a,r3
	add	a,r7
	movp	a,@a
	jmp	L078C		; vytiskni mikroradek znaku

; Sem je skok z HLED, pokud je FLAG1=1. Byte k tisku je xx543210.
; Zde se otoci na xx0123456 a pokud je stisknuto STOP, vytiskne jako
; 1 mikroradek znaku
L0777:	mov	r1,a		; znak k tisku (grafika?)
	in	a,p2		; cti port P2
	anl	a,#$40		; test tlacitka STOP
	jz	L078B		; nestisknuto, skoc
	mov	r6,#$08		; sirka byte je 8 bitu
	clr	a		; nuluj Acc
	clr	c		; nuluj CY
L0781:	xch	a,r1		; prohozeni LSB a MSB bitu 
	rlc	a		;   z R1 do Acc
	xch	a,r1
	rrc	a
	djnz	r6,L0781	; opakuj pro cely byte
	rr	a		; posunuti puvodne bitu 6 na pozici 0 v byte
	rr	a
	jmp	L078C		; vytiskni mikroradek znaku, zde grafiky

;
L078B:	mov	a,r1
L078C:	mov	r5,a		; mikroradek znaku z gen. znaku
	mov	a,#$1F		; vozik vpravo, LOW P1 jako vstup
	mov	r6,#$06		; sirka znaku v bodech
	outl	p1,a		; zapis do BT100
L0792:	in	a,p1		; cti stav BT100
	jb2	L0792		; cekej na synchronizaci bodu
	mov	a,r5		; mikroradek znaku
	rrc	a		; nejnizsi bit do CY
	mov	r5,a		; otoceni mikroradek znaku zpatky
	jnc	L07A0		; bod nenastaven, skoc
	mov	a,#$5F		; vozik vpravo + jehla
	outl	p1,a		; zapis do BT100
	mov	a,#$1F		; jen vozik vpravo
	outl	p1,a		; zapis do BT100
L07A0:	in	a,p1		; cti stav BT100
	cpl	a		; invertuj data
	jb2	L07A0		; cekej na konec synchronizace bodu
	djnz	r6,L0792	; opakuj pro celu sirku znaku (6 bodu)
	mov	a,#$0F		; vse zastavit
	outl	p1,a		; zapis do BT100
	ret			; navrat

; Vyhledani leveho okraje, cekani na SYNC, odradkovani mikroradku
L07AA:	mov	a,#$2F		; vozik vpravo
	outl	p1,a		; rozjed vozik
L07AD:	in	a,p1		; cti stav BT100
	jb0	L07AD		; cekej na doraz voziku
	mov	a,#$1F		; vozik vlevo
	outl	p1,a		; rozjed vozik
L07B3:	in	a,p1		; cti stav BT100
	jb1	L07B3		; cekej na signal SYNC
	cpl	a		; invertuj prectena data
	jb0	L07B3		; cekej na doraz voziku
L07B9:	in	a,p1		; cti stav BT100
	jb2	L07B9		; cekej na signal BOD
	mov	a,#$0F		; LOW P1 jako IN
	outl	p1,a		; zastav vsechny motory
	mov	a,#$8F		; posuv papiru
	outl	p1,a		; posun papir
	in	a,p1		; cti stav BT100
	jb3	L07CB		; cekej na sestupnou hranu posuvu papiru
L07C5:	in	a,p1		; cti stav BT100
	cpl	a		; invertuj prectena data
	jb3	L07C5		; cekej na vzestupnou hranu posuvu papiru
	jmp	L07CE		; zastav motory, navrat

L07CB:	in	a,p1		; cti stav BT100
	jb3	L07CB		; cekej na sestupnou hranu posuvu papiru
L07CE:	mov	a,#$0F		; LOW P1 jako IN
	outl	p1,a		; zastav vsechny motory
	ret			; navrat

HLED:	jf1	L0777		; je-li FLAG1=1, skoc
	mov	r3,#$EC		; -20 - pocet znaku v jedne tabulce
	add	a,#$E0		; -32 - znak ' ' - posunuti pocatku gen. znaku
	jnc	T0		; znak neni v generatoru obsazen, konec
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T1		; nebyl prenos, tabulka 1 (znaky 20h..33h)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T2		; nebyl prenos, tabulka 2 (znaky 34h..47h)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T3		; nebyl prenos, tabulka 3 (znaky 48h..5Bh)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T4		; nebyl prenos, tabulka 4 (znaky 5Ch..6Fh)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T5		; nebyl prenos, tabulka 5 (znaky 70h..83h)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	T6		; nebyl prenos, tabulka 6 (znaky 84h..97h)
	add	a,r3		; odecti velikost jedne tabulky
	jnc	S7		; nebyl prenos, tabulka 7 (znaky 98h..9Fh)
T0:	mov	r4,#$01		; znak nelezi v generatoru znaku
	ret			; navrat

T1:	jmp	S1		; tabulka 1

T2:	jmp	S2		; tabulka 2

T3:	jmp	S3		; tabulka 3

T4:	jmp	S4		; tabulka 4

T5:	jmp	S5		; tabulka 5

T6:	jmp	S6		; tabulka 6

.end